/*
TITULO     : Rotinas para manipulao de arquivo INI
DESDE      : 26/03/2011
PROGRAMA   : ANY_INI.PRG
COMENTARIO : Clipper + CT.LIB  
*/

#include "fileio.ch"
#include "common.ch"

#define CRLF      CHR(13)+CHR(10)

/* Testes */
// aResultado:=Ini_Read("ODBCINST.INI")
// cResultado:=Ini_Find("ODBCINST.INI",Upper("Microsoft Excel Driver (*.xls) (32 bits)"),Upper("Driver"))
// aResultado:=Ini_Extract("ODBCINST.INI",Upper("ODBC 32 bit Drivers"))
// aResultado:=Ini_Insert("ODBCINST.INI",Upper("ODBC 32 bit Drivers"),{"[NetworkS]","PrintBufTimeS=1","[IFSMGR]","PrintBufTime=1"})
// nLinhas:=Ini_Write("NEW.INI",aResultado,.F.)
// aResultado:=Ini_Replace("NEW.INI",{"[NetworkS]","PrintBufTimeS=1"},{"[Network]","PrintBufTime=1"})
// nLinhas:=Ini_Write("NEW.INI",aResultado,.F.)
aResultado:=Ini_Exclude("NEW.INI",{"[Network]","PrintBufTime=1","[IFSMGR]","PrintBufTime=1"})
nLinhas:=Ini_Write("NEW.INI",aResultado,.F.)


Function Ini_Read(cFile)
Local cLine:="",nLine:=0,nTam:=0,aRet:={{},{},{}}
Private lEof:=.f.

nHandle:=Fopen(cFile,0)
If nHandle # -1
   Do While !lEof
      cLine := ReadFile(nHandle,1024)
      If "[" $ cLine .and. "]" $ cLine
         If nTam>0
            aRet[3,nTam]:=nLine
         Endif
         Aadd(aRet[1],Upper(Alltrim(CharRem("[]",cLine))))
         Aadd(aRet[2],nLine+1)
         Aadd(aRet[3],0)
         nTam:=nTam+1
      Endif
      nLine++
   Enddo
Endif
Fclose(nHandle)
Return aRet

Static Function ReadFile(nHandle,nBuffSize)
LOCAL cRet:= cBuff:='', nPos:= nEol:= nRead:=0

cBuff:=Space(nBuffSize)
nPos:=FSeek(nHandle,0,FS_RELATIVE)
IF ( nRead:=FREAD(nHandle,@cBuff,nBuffSize) ) > 0
   IF ( nEol:=AT(CRLF,SUBSTR(cBuff,1,nRead)) ) == 0
      cRet:=SUBSTR(cBuff,1,LEN(cBuff)-1)
   ELSE
      cRet:=SUBSTR(cBuff,1,nEol-1)
      FSeek(nHandle,nPos+nEol+1,FS_SET)
   END
ELSE
   lEof:=.t.
END
Return(cRet)

Function Ini_Find(cFile,cSection,cVariable)
Local aSect:={},aTemp,cRet:=""

aTemp:=Ini_Read(cFile)
p:=0
For u=1 to Len(aTemp[1])
    If aTemp[1,u]=cSection
       p:=u
       Exit
    Endif
Next
If p>0
   aSect:=Ini_List(cFile,aTemp[2,p],aTemp[3,p])
   For i=1 to Len(aSect)
       If Upper(aSect[i])=cVariable
          cRet:=Substr(aSect[i],At("=",aSect[i])+1)
       Endif
   Next
Endif
aLTD()
Return cRet

Function Ini_Extract(cFile,cSection)
Local aSect:={},aTemp

aTemp:=Ini_Read(cFile)
p:=0
For u=1 to Len(aTemp[1])
    If aTemp[1,u]=cSection
       p:=u
       Exit
    Endif
Next
If p>0
   aSect:=Ini_List(cFile,aTemp[2,p],aTemp[3,p])
Endif
Return aSect

Function Ini_List(cFile,nIni,nFin)
Local cLine:="",nLine:=0,aRet:={}
Private lEof:=.f.

nHandle:=Fopen(cFile,0)
If nHandle # -1
   Do While !lEof
      cLine := ReadFile(nHandle,1024)
      nLine++
      If nIni=Nil .and. nFin=Nil
         Aadd(aRet,cLine)
      Else
         If nLine>=nIni .and. nLine<=nFin
            Aadd(aRet,cLine)
         Endif
      Endif
   Enddo
Endif
Fclose(nHandle)
Return aRet

Function Ini_Insert(cFile,cSection,aValues)
Local aTemp1,aTemp2,aTemp3:={}

aTemp1:=Ini_Read(cFile) // obtendo os nomes das seoes
p:=0
For u=1 to Len(aTemp1[1])
    If aTemp1[1,u]=cSection
       p:=u
       Exit
    Endif
Next
If p>0
   aTemp2:=Ini_List(cFile) // Obtendo o arquivo completo
   For u=1 to Len(aTemp2)
       If u=aTemp1[3,p]
          Aadd(aTemp3,aTemp2[u])
          For i=1 to Len(aValues)
              Aadd(aTemp3,aValues[i])
          Next
       Else
          Aadd(aTemp3,aTemp2[u])
       Endif
   Next
Endif
Return aTemp3

Function Ini_Write(cFile,aLines,lEmpty)
Local nLines:=0, nTam:=Len(aLines)

nHandle:=FCreate(cFile,0)
If nHandle # -1
   For i=1 to nTam
       If lEmpty=.F.
          If Len(aLines[i])>0
             FWrite(nHandle,aLines[i]+CRLF)
          Endif
       Else
          FWrite(nHandle,aLines[i]+CRLF)
       Endif
   Next
Endif
FClose(nHandle)
Return nLines

Function Ini_Replace(cFile,aSearch,aReplace)
Local aRet:={}

aRet:=Ini_List(cFile)     // Obtendo o arquivo completo
For u=1 to Len(aSearch)
    For i=1 to Len(aRet)
        If aRet[i]=aSearch[u]
           aRet[i]=aReplace[u]
        Endif
    Next
Next
Return aRet

Function Ini_Exclude(cFile,aExclude)
Local aRet:={},aTemp

aTemp:=Ini_List(cFile)     // Obtendo o arquivo completo
For i=1 to Len(aTemp)
    lFound:=.F.
    For u=1 to Len(aExclude)
        If aTemp[i]=aExclude[u]
           lFound:=.T.
        Endif
    Next
    If lFound=.F.
       Aadd(aRet,aTemp[i])
    Endif
Next
Return aRet
